import {type AlbumID3, type GetAlbumList2Response, OpenSubsonic, type Parameter} from "$lib/opensubsonic";

export class AlbumState {
    list: Array<AlbumID3> = $state(new Array<AlbumID3>())
    loading: boolean = $state(true)
    paginating: boolean = $state(false)
    paginationIncrement: number = $state(100)
    pagination: number = $state(0)
    mode: string = $state("alphabeticalByName")

    async fetchAlbums(): Promise<void> {
        const parameters: Array<Parameter> = [
            {key: "type", value: this.mode},
            {key: "size", value: this.paginationIncrement.toString()},
            {key: "offset", value: this.pagination.toString()},
        ];

        const data: GetAlbumList2Response = await OpenSubsonic.get("getAlbumList2", parameters);
        if (data && data.albumList2.album) {
            this.list = this.list.concat(data.albumList2.album);
            this.pagination += this.paginationIncrement;
            this.paginating = false;
            this.loading = false;
        }
    }

    setMode(mode: string): void {
        this.mode = mode;
    }
}