export enum PlaybackMode {
    Linear,
    LoopOne,
    LoopQueue,
}

export class PlaybackStateSvelte {
    values = {
        [PlaybackMode.Linear]: "1",
        [PlaybackMode.LoopOne]: "0",
        [PlaybackMode.LoopQueue]: "00",
    }

    current: PlaybackMode = $state(PlaybackMode.Linear);

    next = function() {
        if (this.current == PlaybackMode.LoopQueue) {
            this.current = -1;
        }
        return this.values[++this.current];
    }

    prev = function() {
        if (this.current == PlaybackMode.Linear) {
            this.current = this.values.length;
        }
        return this.values[--this.current];
    }

    get = function() {
        return this.values[this.current];
    }
}