import {AlbumView, View} from "$lib/components/custom/Views/views.svelte";

interface ViewState {
    current: ViewDetails,
    previous?: ViewState,
    parent?: ViewState,
    setMode: (newMode: View) => void,
    setSubMode: (newSubMode: AlbumView) => void,
}

interface ViewDetails {
    // sort
    mode: View,
    subMode: AlbumView,
}

export const viewState: ViewState = $state<ViewState>({
    current: {
        mode: View.Albums,
        subMode: AlbumView.All,
    },
    setSubMode(newSubMode: AlbumView): void {
        this.previous = this.current;
        this.current.subMode = newSubMode;
    },
    setMode(newMode: View): void {
        this.previous = this.current;
        this.current.mode = newMode;
    }
})